=== modified file 'NEWS'
--- NEWS	2008-08-15 16:24:50 +0000
+++ NEWS	2008-09-10 00:02:06 +0000
@@ -1,6 +1,17 @@
 What's changed in loggerhead?
 =============================
 
+dev [future]
+
+    - Added --port, --host and --prefix options to serve-branches
+      script. (Martin Albisetti)
+
+    - Fixed broken template for project browsing with start-loggerhead
+      (Martin Albisett)
+      
+    - Added --reload options to restart the application when a python 
+      file change. (Guillermo Gonzalez) 
+
 1.6 [15Aug2008]
 ----------------
 

=== modified file 'README.txt'
--- README.txt	2008-07-26 17:53:10 +0000
+++ README.txt	2008-09-06 20:17:56 +0000
@@ -11,10 +11,16 @@
 GETTING STARTED
 ---------------
 
-Loggerhead depends on SimpleTAL for templating and Paste for the
-server.  So you need these installed -- on Ubuntu you want the
-'python-simpletal' and 'python-paste' packages installed.  You need
-version 1.2 or newer of Paste.
+Loggerhead depends on 
+1) SimpleTAL for templating.
+   on ubuntu package `sudo apt-get install python-simpletal`
+   or download from http://www.owlfish.com/software/simpleTAL/download.html
+2) Paste for the server. (You need version 1.2 or newer of Paste.) 
+   on ubuntu package `sudo apt-get install python-paste`
+   or use `easy_install Paste`
+3) Paste Deploy  (optional, needed when proxying through Apache)
+   on ubuntu package `sudo apt-get install python-pastedeploy`
+   or use `easy_install PasteDeploy`
 
 Then simply run the 'serve-branches' with the branch you want to
 serve on the command line:
@@ -76,10 +82,7 @@
 
 If Paste Deploy is installed, the 'serve-branches' script can be
 run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to add a 'prefix' argument to the
-PrefixMiddleware call in the script.  More flexible configuration
-should be added soon...
-
+some path into the site, you'll need to specify is using '--prefix=/some_path'.
 
 FILES CHANGED CACHE
 -------------------

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2008-07-22 20:07:08 +0000
+++ loggerhead/templates/browse.pt	2008-08-20 22:32:48 +0000
@@ -1,56 +1,44 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+<html xmlns="http://www.w3.org/1999/xhtml">
   <head>
-    <title metal:fill-slot="title">
-      loggerhead branches
-    </title>
+    <title>loggerhead branches</title>
+    <link rel="stylesheet"
+          tal:attributes="href python:branch.static_url('/static/css/global.css')" />
   </head>
 
   <body>
-
-    <h1 metal:fill-slot="heading" style="padding-bottom: 1em">
-      <tal:title condition="title" content="title" />
-      <tal:no-title condition="not:title">
-        bazaar branches in loggerhead
-      </tal:no-title>
-    </h1>
-
-    <div metal:fill-slot="content">
+   <div id="loggerheadCont">
+    <div>
       <div class="browse-project"
            tal:repeat="project projects">
-        <div class="browse-project-name"
-             tal:content="project/friendly_name"></div>
-
+        <h1 tal:content="project/friendly_name" />
         <div class="browse-project-description"
              tal:condition="python:len(project.long_description) > 0"
              tal:content="structure project/long_description"></div>
 
-        <div class="browse-view">
-          <table>
-            <tr class="heading">
-              <th>Name</th>
-              <th>Description</th>
-              <th>Last change</th>
-              <th />
+          <table id="logentries">
+            <tr class="logheader">
+              <th class="summarycell" colspan="2">Name</th>
+              <th class="summarycell">Description</th>
+              <th class="datecell" colspan="2">Last change</th>
             </tr>
             <tal:block repeat="view python:views_by_project[project]">
-              <tr>
-                <td class="name">
-                  <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
-                     tal:content="view/friendly_name">
-                    ${view.friendly_name}
-                  </a>
-                </td>
-                <td class="description"
-                    tal:content="view/description">
-                  ${view.description}
-                </td>
-                <td class="last-update"
-                    tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'"></td>
-                <td class="feed">
+              <tr tal:attributes="class string:blueRow1">
+                <td class="icocell">
+                  <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" />
+                </td>
+                <td class="autcell">
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
+                       tal:content="view/friendly_name" />
+                </td>
+                <td class="autcell"
+                    tal:content="view/description" />
+                <td class="date"
+                    tal:content="python:view.get_history().has_revisions and util._approximatedate(view.last_updated()) or '(no revisions)'" />
+                <td class="icocell">
                   <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name + '/atom')"
                      title="atom feed">
-                    <img tal:attributes="src python:branch.static_url('/static/images/feed-icon-16x16.gif')"
+                    <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')"
                          alt="atom feed" />
                   </a>
                 </td>
@@ -60,16 +48,13 @@
                 </td>
                 <td class="description url" colspan="2">
                   <a tal:attributes="href view/branch_url"
-                     tal:content="view/branch_url">
-                    ${view.branch_url}
-                  </a>
+                     tal:content="view/branch_url" />
                 </td>
               </tr>
             </tal:block>
           </table>
-        </div>
-
       </div>
     </div>
+  </div>
   </body>
 </html>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-08-04 03:42:01 +0000
+++ loggerhead/templates/changelog.pt	2008-08-20 20:47:46 +0000
@@ -106,7 +106,8 @@
                                                 <a tal:attributes="href python:url(['/changes', parent.revno])"
                                                    tal:content="parent/revno"></a>
                                             </span>
-                                            <a tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
+                                            <a tal:condition="parent.branch_nick"
+                                               tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
                                                tal:content="python:'(' + parent.branch_nick + ')'"
                                                 title="Show history" class="link"></a>
                                         </li>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2008-08-19 12:54:33 +0000
+++ loggerhead/templates/macros.pt	2008-08-20 23:37:59 +0000
@@ -39,7 +39,7 @@
         <h1 metal:define-slot="heading"></h1>
         <div metal:define-slot="content"></div>
 
-        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/" class="link">Bazaar</a> branches</p>
+        <p class="fl">Loggerhead is a web-based interface for <a href="http://bazaar-vcs.org/">Bazaar</a> branches</p>
       </div>
   </body>
 </html>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-08-06 21:25:24 +0000
+++ loggerhead/util.py	2008-09-10 00:02:06 +0000
@@ -33,6 +33,9 @@
 import threading
 import time
 import types
+import sys
+import os
+import subprocess
 
 log = logging.getLogger("loggerhead.controllers")
 
@@ -445,3 +448,66 @@
     overrides = dict((k, v) for (k, v) in overrides.iteritems() if k in _valid)
     map.update(overrides)
     return map
+
+
+class Reloader(object):
+    """
+    This class wraps all paste.reloader logic. All methods are @classmethod.
+    """
+
+    _reloader_environ_key = 'PYTHON_RELOADER_SHOULD_RUN'
+
+    @classmethod
+    def _turn_sigterm_into_systemexit(self):
+        """
+        Attempts to turn a SIGTERM exception into a SystemExit exception.
+        """
+        try:
+            import signal
+        except ImportError:
+            return
+        def handle_term(signo, frame):
+            raise SystemExit
+        signal.signal(signal.SIGTERM, handle_term)
+
+    @classmethod
+    def is_installed(self):
+        return os.environ.get(self._reloader_environ_key)
+    
+    @classmethod
+    def install(self):
+        from paste import reloader
+        reloader.install(int(1))
+    
+    @classmethod    
+    def restart_with_reloader(self):
+        """Based on restart_with_monitor from paste.script.serve."""
+        print 'Starting subprocess with file monitor'
+        while 1:
+            args = [sys.executable] + sys.argv
+            new_environ = os.environ.copy()
+            new_environ[self._reloader_environ_key] = 'true'
+            proc = None
+            try:
+                try:
+                    self._turn_sigterm_into_systemexit()
+                    proc = subprocess.Popen(args, env=new_environ)
+                    exit_code = proc.wait()
+                    proc = None
+                except KeyboardInterrupt:
+                    print '^C caught in monitor process'
+                    return 1
+            finally:
+                if (proc is not None
+                    and hasattr(os, 'kill')):
+                    import signal
+                    try:
+                        os.kill(proc.pid, signal.SIGTERM)
+                    except (OSError, IOError):
+                        pass
+                
+            # Reloader always exits with code 3; but if we are
+            # a monitor, any exit code will restart
+            if exit_code != 3:
+                return exit_code
+            print '-'*20, 'Restarting', '-'*20
\ No newline at end of file

=== modified file 'serve-branches'
--- serve-branches	2008-08-20 22:11:54 +0000
+++ serve-branches	2008-09-10 00:02:06 +0000
@@ -28,6 +28,7 @@
 from loggerhead import __version__
 from loggerhead.apps.filesystem import (
     BranchesFromFileSystemRoot, UserBranchesFromFileSystemRoot)
+from loggerhead.util import Reloader
 
 
 def command_line_parser():
@@ -41,11 +42,14 @@
     parser.add_option("--trunk-dir", metavar="DIR",
                       help="The directory that contains the trunk branches.")
     parser.add_option("--port", dest="user_port",
-                      help="Port Loggerhead should listen on. 8080 is the default one.")
+                      help="Port Loggerhead should listen on (defaults to 8080).")
     parser.add_option("--host", dest="user_host",
                       help="Host Loggerhead should listen on.")
     parser.add_option("--prefix", dest="user_prefix",
                       help="Specify host prefix.")
+    parser.add_option("--reload", action="store_true", dest="reload",
+                      help="Restarts the application when changing python"
+                           " files. Only used for development purposes.")
     parser.add_option("--version", action="store_true", dest="show_version",
                       help="Print the software version and exit")
     return parser
@@ -77,6 +81,12 @@
     if options.trunk_dir and not options.user_dirs:
         print "--trunk-dir is only valid with --user-dirs"
         sys.exit(1)
+        
+    if options.reload:
+        if Reloader.is_installed():
+            Reloader.install()
+        else:
+            return Reloader.restart_with_reloader()
 
     if options.user_dirs:
         if not options.trunk_dir:

=== modified file 'serve-branches.1'
--- serve-branches.1	2008-08-05 16:07:16 +0000
+++ serve-branches.1	2008-09-10 00:02:06 +0000
@@ -21,6 +21,9 @@
 \fB\-\-trunk\-dir\fR=\fIDIR\fR
 The directory that contains the trunk branches.
 .TP
+\fB\-\-reload\fR
+Restarts the application when changing python files. Only used for development purposes.
+.TP
 \fB\-\-version\fR
 Print the software version and exit
 .SH "LICENSE"

